"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransformHmr3 = _interopRequireDefault(require("react-transform-hmr"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("@webex/internal-plugin-encryption");

var _storageAdapterLocalStorage = _interopRequireDefault(require("@webex/storage-adapter-local-storage"));

var _webexCore = _interopRequireDefault(require("@webex/webex-core"));

var _components = {
  SparkOAuth: {
    displayName: "SparkOAuth"
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr3.default)({
  filename: "packages/node_modules/@ciscospark/react-component-spark-oauth/src/index.js",
  components: _components,
  locals: [module],
  imports: [_react.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var propTypes = {
  clientId: _propTypes.default.string.isRequired,
  clientSecret: _propTypes.default.string.isRequired,
  doAuth: _propTypes.default.bool,
  onAuth: _propTypes.default.func,
  redirectUri: _propTypes.default.string.isRequired,
  scope: _propTypes.default.string.isRequired
};
var defaultProps = {
  doAuth: false,
  onAuth: function onAuth() {}
};

var SparkOAuth =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(SparkOAuth, _Component);

  function SparkOAuth() {
    (0, _classCallCheck2.default)(this, SparkOAuth);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(SparkOAuth).apply(this, arguments));
  }

  (0, _createClass2.default)(SparkOAuth, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this = this;

      this.spark = new _webexCore.default({
        config: {
          credentials: {
            oauth: {
              client_id: this.props.clientId,
              client_secret: this.props.clientSecret,
              scope: this.props.scope,
              redirect_uri: this.props.redirectUri
            }
          },
          storage: {
            boundedAdapter: new _storageAdapterLocalStorage.default('ciscospark-embedded')
          }
        }
      });
      this.spark.listenToAndRun(this.spark, 'change:canAuthorize', function () {
        _this.checkForOauthToken();
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.doAuth && nextProps.doAuth !== this.props.doAuth) {
        this.spark.authenticate();
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "checkForOauthToken",
    value: function checkForOauthToken() {
      var credentials = this.spark.credentials;

      if (credentials.canAuthorize && credentials.supertoken) {
        var supertoken = credentials.supertoken;
        this.props.onAuth(supertoken.access_token);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);
  return SparkOAuth;
}(_react.Component);

SparkOAuth = _wrapComponent("SparkOAuth")(SparkOAuth);
SparkOAuth.propTypes = propTypes;
SparkOAuth.defaultProps = defaultProps;
var _default2 = SparkOAuth;
exports.default = _default2;